<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.12.1/css/jquery.dataTables.min.css">
    <script src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>
</head>
<body>
<div class="container">
    <div class="container jumbotron">
        <div class="row">
            <div class="col-5">
                <div class="row">
                    <div class="col-4">
                        <label for="">Trạng thái Order</label>
                    </div>
                    <div class="col-8">
                        <select class="form-control" name="" id="select-trang-thai">
                            <option value="all">All</option>
                            <option value="open">Open</option>
                            <option value="confirmed">Confirmed</option>
                            <option value="cancel">Cancel</option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="col-5">
                <div class="row">
                    <div class="col-4">
                        <label for="">Loại Pizza</label>
                    </div>
                    <div class="col-8">
                        <select class="form-control" name="" id="select-loai-pizza">
                            <option value="all">All</option>
                            <option value="hawaii">Hawaii</option>
                            <option value="bacon">Bacon</option>
                            <option value="seafood">Seafood</option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="col-2">
                <button class="btn btn-success btn-search">Tìm kiếm</button>
            </div>
        </div>
    </div>
</div>
<div class="container">
    <div class="row text-center">
        <div class="col-12">
            <h2><b> DANH SÁCH ĐƠN HÀNG</b></h2>
        </div>
    </div>
    <div class="row">
        <div class="col-12 text-center">
            <table class="table table-bordered table-striped table-dark table-hover" id="order-table">
                <thead>
                  <tr>
                    <th>Order ID</th>
                    <th>Kich co combo</th>
                    <th>Loai pizza</th>
                    <th>Nước uống</th>
                    <th>Thành tiền</th>
                    <th>Họ và tên</th>
                    <th>Số điện thoại</th>
                    <th>Trạng thái</th>
                    <th>Chi tiết</th>
                  </tr>
                </thead>
        </div>
        </table>
    </div>
</div>
    
</body>
<script>
    $(document).ready(function(){
        onPageLoading()
        $(".btn-search").click(function(){
            onBtnFilterDataClick()
        })
        
    })
    
    const gARRAY_COL_NAME = ["orderId","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","chiTiet"]
    const gCOL_ORDER_ID = 0;
    const gCOL_KICH_CO_COMBO = 1;
    const gCOL_LOAI_PIZZA= 2;
    const gCOL_NUOC_UONG = 3;
    const gCOL_THANH_TIEN = 4;
    const gCOL_HO_VA_TEN = 5;
    const gCOL_SO_DIEN_THOAI = 6;
    const gCOL_TRANG_THAI = 7;
    const gCOL_CHI_TIET = 8;
    const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
    var gOrderObj
    //hàm load trang
    function onPageLoading(){
        getApiToGetOrder();
        loadDataToOrderTable(gOrderObj);
        $("#order-table").on("click",".btn-detail",function(){
            onBtnDetailClick(this)
        })
    }
    // thêm dữ liệu vào bảng
    $('#order-table').DataTable({
        columns: [{
                data: gARRAY_COL_NAME[gCOL_ORDER_ID]
            },
            {
                data: gARRAY_COL_NAME[gCOL_KICH_CO_COMBO]
            },
            {
                data: gARRAY_COL_NAME[gCOL_LOAI_PIZZA]
            },
            {
                data: gARRAY_COL_NAME[gCOL_NUOC_UONG]
            },
            {
                data: gARRAY_COL_NAME[gCOL_THANH_TIEN]
            },
            {
                data: gARRAY_COL_NAME[gCOL_HO_VA_TEN]
            },
            {
                data: gARRAY_COL_NAME[gCOL_SO_DIEN_THOAI]
            },
            {
                data: gARRAY_COL_NAME[gCOL_TRANG_THAI]
            },
            {
                data: gARRAY_COL_NAME[gCOL_CHI_TIET]
            },

        ],
        columnDefs: [
            {
                targets: gCOL_CHI_TIET,
                className: 'text-center',
                defaultContent: `<button class = "btn btn-primary btn-detail">Chi tiết</button>`
            }
        ],
        autoWidth: false,
    });
    // hàm gọi api order
    function getApiToGetOrder(){
        $.ajax({
            async:false,
            url: gBASE_URL,
            type: "GET",
            dataType:'json',
            success:function(res){
                //console.log(res)
                gOrderObj = res;
            },
            error:function(error){
                alert(error.responseText)
                console.assert(error)
            }
        })
    }
    //hàm vẽ lại bảng
    function loadDataToOrderTable(paramObjUser) {
        'use strict';
        var vTable = $('#order-table').DataTable();
        vTable.clear();
        vTable.rows.add(paramObjUser);
        vTable.draw();
    }
    //hàm hiển thị thông tin nút chi tiết
    function onBtnDetailClick(paramBtnDelete) {
        'use strict';
        console.log('Button detail Clicked rồi đó ba !!!')
        var vCurrentRow = $(paramBtnDelete).closest('tr');
        var vTable = $('#order-table').DataTable();
        var vDataRow = vTable.row(vCurrentRow).data();
        console.log(vDataRow);

    }
    function onBtnFilterDataClick(){
        console.log("filter đã được chạy")
        var vStatus = $("#select-trang-thai").val();
        var vPizzaType = $("#select-loai-pizza").val();
        var vDataFilter = gOrderObj.filter(function(item){
            return(vStatus == "all"|| item.trangThai == vStatus)&&(vPizzaType == "all" || item.loaiPizza == vPizzaType)
        })
        loadDataToOrderTable(vDataFilter);
    }

</script>
</html>